;; inspiration from: https://github.com/aartaka/nyxt-config/blob/master/config.lisp

(in-package :nyxt-user)

;; search engines
(defvar *my-search-engines*
  (list
   '("wiki" "https://en.wikipedia.org/w/index.php?search=~a" "https://en.wikipedia.org/")
   '("kagi" "https://kagi.com/search?q=~a" "https://www.kagi.com/")))

(defvar *web-buffer-modes*
  '(:blocker-mode
    :reduce-tracking-mode))

(define-configuration browser
  ((restore-session-on-startup-p t)
   ;; (default-new-buffer-url (quri:uri "https://github.com/atlas-engineer/nyxt"))
   (external-editor-program '("emacsclient -r"))))

(define-configuration context-buffer
  "Go through the search engines above and make-search-engine"
  ((search-engines
    (append %slot-default%
            (mapcar
             (lambda (engine) (apply 'make-search-engine engine))
             *my-search-engines*)))))

;; auto bookmark frequently visited sites
(define-configuration bookmark-frequent-visits-mode
    ((threshold 10)))

;; set web buffer default modes from *web-buffer-modes* above
(define-configuration web-buffer
  "Basic modes setup for web-buffer."
  ((default-modes `(,@*web-buffer-modes* ,@%slot-value%))))

(define-configuration hint-mode
  "Set up QWERTY home row as the hint keys."
  ((hints-alphabet "DSJKHLFAGNMXCWEIO")))

(define-configuration prompt-buffer
  ((hide-single-source-header-p
    t
    :doc "This is to hide the header is there's only one source.
There also used to be other settings to make prompt-buffer a bit
more minimalist, but those are internal APIs :(")))

;; key binds
;; (defvar mnl-keys (make-keyscheme cua))
